## LLEU project, faq product
## Copyright (C) 2000  J. David Ibez, Andres Marzal
##                     Universitat Jaume I, Spain
## email: al028823@alumail.uji.es

## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

__doc__ = """Items manager"""
__version__ = "0.1"

import Persistence


##from Shared.xmlio import XMLio

class OrderedList(Persistence.Persistent):
  def __init__(self):
    self.items = []

  def __len__(self):
    return len(self.items)

  def __getitem__(self, i):
    return self.items[i]

  def insert(self, i, x):
    self.items.insert(i, x)
    self.__changed__(1)

  def remove(self, x):
    self.items.remove(x)
    self.__changed__(1)

  def rearrange(self, new_positions):
    n_items = len(self.items)
    items = [None] * n_items

    change = 0
    for i in range(n_items):
      new_position = new_positions[i]
      items[new_position] = self.items[i]
      if i != new_position:
        change = 1

    if items.count(None) > 0:
      raise 'Bad order'

    if change:
      self.items = items
      self.__changed__(1)
    return change
